class
	ASSEMBLER_TRANSFORMER

inherit
	TRANSFORMATION_STEP
	AST_DEFAULT_VISITOR
		redefine
			end_visit_assembler_statement
		end

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		do
			assembler_statements.wipe_out
			transformer.tree.accept (Current)
			Result := True
		end

	description: STRING
		do
			Result := "Transforming inline assembler"
		end

feature {ANY} -- transformation information, kept until next invocation

	assembler_statements: LIST [AST_ASSEMBLER_STATEMENT]
		once ("PROCESS")
			Result := create {TWO_WAY_LIST [AST_ASSEMBLER_STATEMENT]}.make
			Result.compare_objects
		end

feature {ANY} -- AST_DEFAULT_VISITOR

	end_visit_assembler_statement (node: AST_ASSEMBLER_STATEMENT)
		local
			l_asm_index: INTEGER_32
			l_asm_call: AST_EIFFEL_EXPRESSION
		do
			l_asm_index:= assembler_statements.index_of (node, 1)
			if l_asm_index = 0 then
				assembler_statements.extend (node)
				l_asm_index := assembler_statements.count
			end

			create l_asm_call.make ("asm" + l_asm_index.out, create {AST_BASIC_TYPE}.make (Ast_bt_void))
			if not node.accessed_variables.is_empty then
				({STRING_8} #? l_asm_call.mixed.last).append (" (")
				across node.accessed_variables as c loop
					if c.target_index > 1 then
						l_asm_call.mixed.extend (", ")
					end
					l_asm_call.mixed.extend (create {AST_UNARY_EXPRESSION}.make (C_op_bitand, c.item.ast_twin))
					({AST_NODE} #? l_asm_call.mixed.last).parent := l_asm_call
				end
				l_asm_call.mixed.extend (")")
			end

			replace_node (node, create {AST_EXPRESSION_STATEMENT}.make (l_asm_call))
		end

end
