class
	FLUSH_TRANSFORMER

inherit
	TRANSFORMATION_STEP
	AST_DEFAULT_VISITOR
		redefine
			end_visit_function_call
		end

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		do
			transformer.tree.accept (Current)
			Result := True
		end

	description: STRING
		do
			Result := "Transforming %"flush%" to the Eiffel equivalent"
		end

feature {ANY} -- AST_DEFAULT_VISITOR

	end_visit_function_call (node: AST_FUNCTION_CALL)
		do
			-- `fflush(stdout)' ->  `Io.standard_default.flush'
			if
				node.identifier_str /= Void and then node.identifier_str.is_equal ("fflush") and then
				node.parameters.count = 1 and then
				attached {AST_VARIABLE_EXPRESSION} node.parameters.first as pe
			then
				if pe.identifier.is_equal ("stdout") then
					replace_node (node, create {AST_EIFFEL_EXPRESSION}.make (
							"Io.standard_default.flush",
							create {AST_BASIC_TYPE}.make (Ast_bt_void)
						))
				elseif pe.identifier.is_equal ("stderr") then
					replace_node (node, create {AST_EIFFEL_EXPRESSION}.make (
							"Io.error.flush",
							create {AST_BASIC_TYPE}.make (Ast_bt_void)
						))
				end
			end
		end

end
