class
	STRUCT_TRANSFORMER

inherit
	TRANSFORMATION_STEP
	AST_DEFAULT_VISITOR
		redefine
			end_visit_assignment_expression
		end
	AST_UTILITIES

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		do
			transformer.tree.accept (Current)
			Result := True
		end

	description: STRING
		do
			Result := "Synchronizing structs/unions where necessary"
		end

feature {ANY} -- AST_DEFAULT_VISITOR

	end_visit_assignment_expression (a_node: AST_ASSIGNMENT_EXPRESSION)
		do
			-- add a call to `update_class_fields' after assignments to union fields
			if
				attached {AST_POSTFIX_EXPRESSION} a_node.target as pe and then
				attached {AST_VARIABLE_EXPRESSION} pe.base_expression as ve and then
				attached {AST_STRUCT_TYPE} ve.declaration_binding.type as st and then
				st.is_union
			then
				insert_adjacent_statement (
						{AST_STATEMENT} #? a_node.parent,
						create {AST_EXPRESSION_STATEMENT}.make (create {AST_EIFFEL_EXPRESSION}.make_mixed (
								<<ve.ast_twin, ".update_class_fields -- synchronize union">>,
								create {AST_BASIC_TYPE}.make (Ast_bt_void)
							)),
						True
					)
			end
		end

end
