class
	AST_AGENT_VISITOR

inherit
	AST_VISITOR

feature {ANY}

	pre_visit (node: AST_NODE) do end

	post_visit_agent: PROCEDURE [ANY, TUPLE [AST_NODE]] assign set_post_visit_agent
	set_post_visit_agent (a: PROCEDURE [ANY, TUPLE [AST_NODE]]) do post_visit_agent := a end

	post_visit (node: AST_NODE)
		do
			if post_visit_agent /= Void then
				post_visit_agent.call ([node])
			end
		end

feature {ANY}

	visit_array_type_agent: PREDICATE [ANY, TUPLE [AST_ARRAY_TYPE]] assign set_visit_array_type_agent
	set_visit_array_type_agent (a: PREDICATE [ANY, TUPLE [AST_ARRAY_TYPE]]) do visit_array_type_agent := a end

	visit_array_type (node: AST_ARRAY_TYPE): BOOLEAN
		do
			if visit_array_type_agent /= Void then
				Result := visit_array_type_agent.item ([node])
			else
				Result := True
			end
		end

	visit_assembler_statement (node: AST_ASSEMBLER_STATEMENT): BOOLEAN do Result := True end
	visit_asm_operand (node: AST_ASM_OPERAND): BOOLEAN do Result := True end
	visit_attribute (node: AST_GCC_ATTRIBUTE): BOOLEAN do Result := True end
	visit_attribute_specifier (node: AST_GCC_ATTRIBUTE_SPECIFIER): BOOLEAN do Result := True end
	visit_basic_type (node: AST_BASIC_TYPE): BOOLEAN do Result := True end
	visit_bit_field (node: AST_BITFIELD): BOOLEAN do Result := True end
	visit_builtin_va_arg_call (node: AST_BUILTIN_VA_ARG_CALL): BOOLEAN do Result := True end
	visit_alignof_call (node: AST_ALIGNOF_CALL): BOOLEAN do Result := True end
	visit_initializer (node: AST_INITIALIZER): BOOLEAN do Result := True end
	visit_assignment_expression (node: AST_ASSIGNMENT_EXPRESSION): BOOLEAN do Result := True end
	visit_boolean_constant (node: AST_BOOLEAN_CONSTANT): BOOLEAN do Result := True end

	visit_cast_expression_agent: PREDICATE [ANY, TUPLE [AST_CAST_EXPRESSION]] assign set_visit_cast_expression_agent
	set_visit_cast_expression_agent (a: PREDICATE [ANY, TUPLE [AST_CAST_EXPRESSION]]) do visit_cast_expression_agent := a end

	visit_cast_expression (node: AST_CAST_EXPRESSION): BOOLEAN
		do
			if visit_cast_expression_agent /= Void then
				Result := visit_cast_expression_agent.item ([node])
			else
				Result := True
			end
		end

	visit_character_constant (node: AST_CHARACTER_CONSTANT): BOOLEAN do Result := True end
	visit_compound_statement (node: AST_COMPOUND_STATEMENT): BOOLEAN do Result := True end
	visit_decimal_constant (node: AST_DECIMAL_CONSTANT): BOOLEAN do Result := True end
	visit_eiffel_expression (node: AST_EIFFEL_EXPRESSION): BOOLEAN do Result := True end
	visit_eiffel_jump (node: AST_EIFFEL_JUMP): BOOLEAN do Result := True end
	visit_eiffel_jump_state (node: AST_EIFFEL_JUMP_STATE): BOOLEAN do Result := True end
	visit_eiffel_string_type (node: AST_EIFFEL_STRING_TYPE): BOOLEAN do Result := True end
	visit_eiffel_type (node: AST_EIFFEL_TYPE): BOOLEAN do Result := True end
	visit_enum_declaration (node: AST_ENUM_DECLARATION): BOOLEAN do Result := True end
	visit_enum_type (node: AST_ENUM_TYPE): BOOLEAN do Result := True end
	visit_expression_statement (node: AST_EXPRESSION_STATEMENT): BOOLEAN do Result := True end
	visit_floating_point_constant (node: AST_FLOATING_POINT_CONSTANT): BOOLEAN do Result := True end

	visit_function_call_agent: PREDICATE [ANY, TUPLE [AST_FUNCTION_CALL]] assign set_visit_function_call_agent
	set_visit_function_call_agent (a: PREDICATE [ANY, TUPLE [AST_FUNCTION_CALL]]) do visit_function_call_agent := a end

	visit_function_call (node: AST_FUNCTION_CALL): BOOLEAN
		do
			if visit_function_call_agent /= Void then
				Result := visit_function_call_agent.item ([node])
			else
				Result := True
			end
		end

	visit_function_declaration_agent: PREDICATE [ANY, TUPLE [AST_FUNCTION_DECLARATION]] assign set_visit_function_declaration_agent
	set_visit_function_declaration_agent (a: PREDICATE [ANY, TUPLE [AST_FUNCTION_DECLARATION]]) do visit_function_declaration_agent := a end

	visit_function_declaration (node: AST_FUNCTION_DECLARATION): BOOLEAN
		do
			if visit_function_declaration_agent /= Void then
				Result := visit_function_declaration_agent.item ([node])
			else
				Result := True
			end
		end

	visit_function_type (node: AST_FUNCTION_TYPE): BOOLEAN do Result := True end
	visit_generic_expression (node: AST_GENERIC_EXPRESSION): BOOLEAN do Result := True end
	visit_hex_constant (node: AST_HEX_CONSTANT): BOOLEAN do Result := True end

	visit_if_statement_agent: PREDICATE [ANY, TUPLE [AST_IF_STATEMENT]] assign set_visit_if_statement_agent
	set_visit_if_statement_agent (a: PREDICATE [ANY, TUPLE [AST_IF_STATEMENT]]) do visit_if_statement_agent := a end

	visit_if_statement (node: AST_IF_STATEMENT): BOOLEAN
		do
			if visit_if_statement_agent /= Void then
				Result := visit_if_statement_agent.item ([node])
			else
				Result := True
			end
		end

	visit_jump_statement (node: AST_JUMP_STATEMENT): BOOLEAN do Result := True end
	visit_labeled_statement (node: AST_LABELED_STATEMENT): BOOLEAN do Result := True end
	visit_octal_constant (node: AST_OCTAL_CONSTANT): BOOLEAN do Result := True end
	visit_parameter_list (node: AST_PARAMETER_LIST): BOOLEAN do Result := True end
	visit_parenthesized_expression (node: AST_PARENTHESIZED_EXPRESSION): BOOLEAN do Result := True end

	visit_pointer_type_agent: PREDICATE [ANY, TUPLE [AST_POINTER_TYPE]] assign set_visit_pointer_type_agent
	set_visit_pointer_type_agent (a: PREDICATE [ANY, TUPLE [AST_POINTER_TYPE]]) do visit_pointer_type_agent := a end

	visit_pointer_type (node: AST_POINTER_TYPE): BOOLEAN
		do
			if visit_pointer_type_agent /= Void then
				Result := visit_pointer_type_agent.item ([node])
			else
				Result := True
			end
		end

	visit_postfix_expression_agent: PREDICATE [ANY, TUPLE [AST_POSTFIX_EXPRESSION]] assign set_visit_postfix_expression_agent
	set_visit_postfix_expression_agent (a: PREDICATE [ANY, TUPLE [AST_POSTFIX_EXPRESSION]]) do visit_postfix_expression_agent := a end

	visit_postfix_expression (node: AST_POSTFIX_EXPRESSION): BOOLEAN
		do
			if visit_postfix_expression_agent /= Void then
				Result := visit_postfix_expression_agent.item ([node])
			else
				Result := True
			end
		end

	visit_sizeof_expression (node: AST_SIZEOF_EXPRESSION): BOOLEAN do Result := True end
	visit_string_constant (node: AST_STRING_CONSTANT): BOOLEAN do Result := True end
	visit_struct_declaration (node: AST_STRUCT_DECLARATION): BOOLEAN do Result := True end
	visit_struct_type (node: AST_STRUCT_TYPE): BOOLEAN do Result := True end
	visit_switch_case (node: AST_SWITCH_CASE): BOOLEAN do Result := True end
	visit_switch_default (node: AST_SWITCH_DEFAULT): BOOLEAN do Result := True end
	visit_switch_statement (node: AST_SWITCH_STATEMENT): BOOLEAN do Result := True end
	visit_translation_unit (node: AST_TRANSLATION_UNIT): BOOLEAN do Result := True end
	visit_typedef_declaration (node: AST_TYPEDEF_DECLARATION): BOOLEAN do Result := True end
	visit_typedef_type (node: AST_TYPEDEF_TYPE): BOOLEAN do Result := True end
	visit_unary_expression (node: AST_UNARY_EXPRESSION): BOOLEAN do Result := True end
	visit_variable_declaration (node: AST_VARIABLE_DECLARATION): BOOLEAN do Result := True end

	visit_variable_expression_agent: PREDICATE [ANY, TUPLE [AST_VARIABLE_EXPRESSION]] assign set_visit_variable_expression_agent
	set_visit_variable_expression_agent (a: PREDICATE [ANY, TUPLE [AST_VARIABLE_EXPRESSION]]) do visit_variable_expression_agent := a end

	visit_variable_expression (node: AST_VARIABLE_EXPRESSION): BOOLEAN
		do
			if visit_variable_expression_agent /= Void then
				Result := visit_variable_expression_agent.item ([node])
			else
				Result := True
			end
		end

	visit_while_statement (node: AST_WHILE_STATEMENT): BOOLEAN do Result := True end

feature {ANY}

	end_visit_array_type (node: AST_ARRAY_TYPE) do end
	end_visit_assembler_statement (node: AST_ASSEMBLER_STATEMENT) do end
	end_visit_asm_operand (node: AST_ASM_OPERAND) do end
	end_visit_attribute (node: AST_GCC_ATTRIBUTE) do end
	end_visit_attribute_specifier (node: AST_GCC_ATTRIBUTE_SPECIFIER) do end
	end_visit_basic_type (node: AST_BASIC_TYPE) do end
	end_visit_bit_field (node: AST_BITFIELD) do end
	end_visit_builtin_va_arg_call (node: AST_BUILTIN_VA_ARG_CALL) do end
	end_visit_alignof_call (node: AST_ALIGNOF_CALL) do end
	end_visit_initializer (node: AST_INITIALIZER) do end
	end_visit_assignment_expression (node: AST_ASSIGNMENT_EXPRESSION) do end
	end_visit_boolean_constant (node: AST_BOOLEAN_CONSTANT) do end

	end_visit_cast_expression_agent: PROCEDURE [ANY, TUPLE [AST_CAST_EXPRESSION]] assign set_end_visit_cast_expression_agent
	set_end_visit_cast_expression_agent (a: PROCEDURE [ANY, TUPLE [AST_CAST_EXPRESSION]]) do end_visit_cast_expression_agent := a end

	end_visit_cast_expression (node: AST_CAST_EXPRESSION)
		do
			if end_visit_cast_expression_agent /= Void then
				end_visit_cast_expression_agent.call ([node])
			end
		end

	end_visit_character_constant (node: AST_CHARACTER_CONSTANT) do end
	end_visit_compound_statement (node: AST_COMPOUND_STATEMENT) do end
	end_visit_decimal_constant (node: AST_DECIMAL_CONSTANT) do end
	end_visit_eiffel_expression (node: AST_EIFFEL_EXPRESSION) do end
	end_visit_eiffel_jump (node: AST_EIFFEL_JUMP) do end

	end_visit_eiffel_jump_state_agent: PROCEDURE [ANY, TUPLE [AST_EIFFEL_JUMP_STATE]] assign set_end_visit_eiffel_jump_state_agent
	set_end_visit_eiffel_jump_state_agent (a: PROCEDURE [ANY, TUPLE [AST_EIFFEL_JUMP_STATE]]) do end_visit_eiffel_jump_state_agent := a end

	end_visit_eiffel_jump_state (node: AST_EIFFEL_JUMP_STATE)
		do
			if end_visit_eiffel_jump_state_agent /= Void then
				end_visit_eiffel_jump_state_agent.call ([node])
			end
		end

	end_visit_eiffel_string_type (node: AST_EIFFEL_STRING_TYPE) do end
	end_visit_eiffel_type (node: AST_EIFFEL_TYPE) do end
	end_visit_enum_declaration (node: AST_ENUM_DECLARATION) do end
	end_visit_enum_type (node: AST_ENUM_TYPE) do end
	end_visit_expression_statement (node: AST_EXPRESSION_STATEMENT) do end
	end_visit_floating_point_constant (node: AST_FLOATING_POINT_CONSTANT) do end
	end_visit_function_call (node: AST_FUNCTION_CALL) do end
	end_visit_function_declaration (node: AST_FUNCTION_DECLARATION) do end
	end_visit_function_type (node: AST_FUNCTION_TYPE) do end
	end_visit_generic_expression (node: AST_GENERIC_EXPRESSION) do end
	end_visit_hex_constant (node: AST_HEX_CONSTANT) do end

	end_visit_if_statement_agent: PROCEDURE [ANY, TUPLE [AST_IF_STATEMENT]] assign set_end_visit_if_statement_agent
	set_end_visit_if_statement_agent (a: PROCEDURE [ANY, TUPLE [AST_IF_STATEMENT]]) do end_visit_if_statement_agent := a end

	end_visit_if_statement (node: AST_IF_STATEMENT)
		do
			if end_visit_if_statement_agent /= Void then
				end_visit_if_statement_agent.call ([node])
			end
		end

	end_visit_jump_statement_agent: PROCEDURE [ANY, TUPLE [AST_JUMP_STATEMENT]] assign set_end_visit_jump_statement_agent
	set_end_visit_jump_statement_agent (a: PROCEDURE [ANY, TUPLE [AST_JUMP_STATEMENT]]) do end_visit_jump_statement_agent := a end

	end_visit_jump_statement (node: AST_JUMP_STATEMENT)
		do
			if end_visit_jump_statement_agent /= Void then
				end_visit_jump_statement_agent.call ([node])
			end
		end

	end_visit_labeled_statement (node: AST_LABELED_STATEMENT) do end
	end_visit_octal_constant (node: AST_OCTAL_CONSTANT) do end
	end_visit_parameter_list (node: AST_PARAMETER_LIST) do end
	end_visit_parenthesized_expression (node: AST_PARENTHESIZED_EXPRESSION) do end
	end_visit_pointer_type (node: AST_POINTER_TYPE) do end
	end_visit_postfix_expression (node: AST_POSTFIX_EXPRESSION) do end
	end_visit_sizeof_expression (node: AST_SIZEOF_EXPRESSION) do end
	end_visit_string_constant (node: AST_STRING_CONSTANT) do end
	end_visit_struct_declaration (node: AST_STRUCT_DECLARATION) do end
	end_visit_struct_type (node: AST_STRUCT_TYPE) do end

	end_visit_switch_case_agent: PROCEDURE [ANY, TUPLE [AST_SWITCH_CASE]] assign set_end_visit_switch_case_agent
	set_end_visit_switch_case_agent (a: PROCEDURE [ANY, TUPLE [AST_SWITCH_CASE]]) do end_visit_switch_case_agent := a end

	end_visit_switch_case (node: AST_SWITCH_CASE)
		do
			if end_visit_switch_case_agent /= Void then
				end_visit_switch_case_agent.call ([node])
			end
		end

	end_visit_switch_default_agent: PROCEDURE [ANY, TUPLE [AST_SWITCH_DEFAULT]] assign set_end_visit_switch_default_agent
	set_end_visit_switch_default_agent (a: PROCEDURE [ANY, TUPLE [AST_SWITCH_DEFAULT]]) do end_visit_switch_default_agent := a end

	end_visit_switch_default (node: AST_SWITCH_DEFAULT)
		do
			if end_visit_switch_default_agent /= Void then
				end_visit_switch_default_agent.call ([node])
			end
		end

	end_visit_switch_statement (node: AST_SWITCH_STATEMENT) do end
	end_visit_translation_unit (node: AST_TRANSLATION_UNIT) do end
	end_visit_typedef_declaration (node: AST_TYPEDEF_DECLARATION) do end
	end_visit_typedef_type (node: AST_TYPEDEF_TYPE) do end

	end_visit_unary_expression_agent: PROCEDURE [ANY, TUPLE [AST_UNARY_EXPRESSION]] assign set_end_visit_unary_expression_agent
	set_end_visit_unary_expression_agent (a: PROCEDURE [ANY, TUPLE [AST_UNARY_EXPRESSION]]) do end_visit_unary_expression_agent := a end

	end_visit_unary_expression (node: AST_UNARY_EXPRESSION)
		do
			if end_visit_unary_expression_agent /= Void then
				end_visit_unary_expression_agent.call ([node])
			end
		end

	end_visit_variable_declaration_agent: PROCEDURE [ANY, TUPLE [AST_VARIABLE_DECLARATION]] assign set_end_visit_variable_declaration_agent
	set_end_visit_variable_declaration_agent (a: PROCEDURE [ANY, TUPLE [AST_VARIABLE_DECLARATION]]) do end_visit_variable_declaration_agent := a end

	end_visit_variable_declaration (node: AST_VARIABLE_DECLARATION)
		do
			if end_visit_variable_declaration_agent /= Void then
				end_visit_variable_declaration_agent.call ([node])
			end
		end

	end_visit_variable_expression_agent: PROCEDURE [ANY, TUPLE [AST_VARIABLE_EXPRESSION]] assign set_end_visit_variable_expression_agent
	set_end_visit_variable_expression_agent (a: PROCEDURE [ANY, TUPLE [AST_VARIABLE_EXPRESSION]]) do end_visit_variable_expression_agent := a end

	end_visit_variable_expression (node: AST_VARIABLE_EXPRESSION)
		do
			if end_visit_variable_expression_agent /= Void then
				end_visit_variable_expression_agent.call ([node])
			end
		end

	end_visit_while_statement_agent: PROCEDURE [ANY, TUPLE [AST_WHILE_STATEMENT]] assign set_end_visit_while_statement_agent
	set_end_visit_while_statement_agent (a: PROCEDURE [ANY, TUPLE [AST_WHILE_STATEMENT]]) do end_visit_while_statement_agent := a end

	end_visit_while_statement (node: AST_WHILE_STATEMENT)
		do
			if end_visit_while_statement_agent /= Void then
				end_visit_while_statement_agent.call ([node])
			end
		end

end
