class
	CONFIG_DIALOG

inherit
	EV_DIALOG

	EV_DIALOG_CONSTANTS
		export
			{NONE} all
		undefine
			default_create, copy
		end

	CODE_TRANSFORMER_CONFIG
		undefine
			copy, default_create
		end

create
	make

feature

	make (a_config_changed_action: PROCEDURE [ANY, TUPLE])
		local
			config: CODE_TRANSFORMER_CONFIG
			v_box: EV_VERTICAL_BOX
			button_box: EV_HORIZONTAL_BOX
			apply_button, cancel_button: EV_BUTTON
		do
			make_with_title ("select transformers")
			config_changed_action := a_config_changed_action

			create v_box
			create config

			-- check buttons
			create cil_transformers_button.make_with_text ("cil transformers")
			cil_transformers_button.select_actions.extend (agent cil_transformers_button_clicked)
			set_selection_state (cil_transformers_button, config.run_cil_transformers)
			v_box.extend (cil_transformers_button)
			create string_transformer_button.make_with_text ("string transformer")
			string_transformer_button.select_actions.extend (agent string_transformer_button_clicked)
			set_selection_state (string_transformer_button, config.run_string_transformer)
			v_box.extend (string_transformer_button)
			create printf_transformer_button.make_with_text ("printf transformer")
			set_selection_state (printf_transformer_button, config.run_printf_transformer)
			v_box.extend (printf_transformer_button)
			create bcr_transformer_button.make_with_text ("break continue return transformer")
			set_selection_state (bcr_transformer_button, config.run_bcr_transformer)
			v_box.extend (bcr_transformer_button)

			-- apply and cancel buttons
			create button_box
			create apply_button.make_with_text_and_action (ev_save, agent apply_button_clicked)
			button_box.extend (apply_button)
			create cancel_button.make_with_text_and_action (ev_cancel, agent cancel_button_clicked)
			button_box.extend (cancel_button)
			v_box.extend (button_box)

			-- set main widget
			extend (v_box)

			-- set default buttons
			set_default_push_button (apply_button)
			set_default_cancel_button (cancel_button)
		end

feature {NONE} -- Widgets

	cil_transformers_button: EV_CHECK_BUTTON

	string_transformer_button: EV_CHECK_BUTTON

	printf_transformer_button: EV_CHECK_BUTTON

	bcr_transformer_button: EV_CHECK_BUTTON

feature {NONE} -- Actions

	config_changed_action: PROCEDURE [ANY, TUPLE]

	apply_button_clicked
		local
			config: CODE_TRANSFORMER_CONFIG
		do
			create config

			-- update config
			config.set_run_cil_transformers (cil_transformers_button.is_selected)
			config.set_run_string_transformer (string_transformer_button.is_selected)
			config.set_run_printf_transformer (printf_transformer_button.is_selected)
			config.set_run_bcr_transformer (bcr_transformer_button.is_selected)

			-- exectue config changed action
			config_changed_action.call ([])

			destroy
		end

	cancel_button_clicked
		do
			destroy
		end

	string_transformer_button_clicked
		do
			if string_transformer_button.is_selected then
				cil_transformers_button.enable_select
			end
		end

	cil_transformers_button_clicked
		do
			if not cil_transformers_button.is_selected then
				string_transformer_button.disable_select
			end
		end

feature {NONE} -- Implementation

	set_selection_state (button: EV_CHECK_BUTTON; selected: BOOLEAN)
		do
			if selected then
				button.enable_select
			else
				button.disable_select
			end
		end

end
